"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.show = show;
exports.clear = clear;

var _react = _interopRequireWildcard(require("react"));

var _noop = require("../../utils/noop");

var _getContainer = require("../../utils/get-container");

var _reactDom = _interopRequireDefault(require("react-dom"));

var _ahooks = require("ahooks");

var _toast = require("./toast");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var toastArray = [];

function show(p) {
  var props = typeof p === 'string' ? {
    content: p
  } : p;
  var timer = 0;
  var _props$afterClose = props.afterClose,
      afterClose = _props$afterClose === void 0 ? _noop.noop : _props$afterClose,
      _props$getContainer = props.getContainer,
      getContainer = _props$getContainer === void 0 ? function () {
    return document.body;
  } : _props$getContainer;
  var container = document.createElement('div');
  var bodyContainer = (0, _getContainer.resolveContainer)(getContainer);
  bodyContainer.appendChild(container);

  var TempToast = function TempToast() {
    var _useState = (0, _react.useState)(true),
        visible = _useState[0],
        setVisible = _useState[1];

    var _useState2 = (0, _react.useState)(Object.assign({
      duration: 2000
    }, props)),
        state = _useState2[0],
        setState = _useState2[1]; // clearDOM after animation


    var _afterClose = function _afterClose() {
      afterClose();

      var unmountResult = _reactDom["default"].unmountComponentAtNode(container);

      if (unmountResult && container.parentNode) {
        container.parentNode.removeChild(container);
      }
    }; // close with animation


    var destroy = (0, _react.useCallback)(function () {
      setVisible(false);
    }, []);
    (0, _react.useEffect)(function () {
      _clear();

      toastArray.push(_afterClose);
    }, []);
    (0, _react.useEffect)(function () {
      if (state.duration !== 0 && 'duration' in state) {
        timer = window.setTimeout(destroy, state.duration);
      }

      return function () {
        if (timer !== 0) {
          window.clearTimeout(timer);
        }
      };
    }, []); // 当修改 duration 时，重新计时

    (0, _ahooks.useUpdateEffect)(function () {
      if ('duration' in state) {
        window.clearTimeout(timer);
        timer = window.setTimeout(destroy, state.duration);
      }
    }, [state.duration]);
    return /*#__PURE__*/_react["default"].createElement(_toast.InternalToast, Object.assign({}, state, {
      getContainer: function getContainer() {
        return container;
      },
      visible: visible,
      afterClose: _afterClose
    }));
  };

  _reactDom["default"].render( /*#__PURE__*/_react["default"].createElement(TempToast, null), container);
} // 同步的销毁


function _clear() {
  var fn = toastArray.pop();

  while (fn) {
    fn();
    fn = toastArray.pop();
  }
} // 针对 toast 还没弹出来就立刻销毁的情况，将销毁放到下一个 event loop 中，避免销毁失败。


function clear() {
  setTimeout(_clear);
}