"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DesenseText = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _nativeProps = require("../../utils/native-props");

var _withDefaultProps = require("../../utils/with-default-props");

var _icons = _interopRequireDefault(require("@ant-design/icons"));

var _iconEye = require("../icons/icon-eye");

var _iconEyeClose = require("../icons/icon-eye-close");

var _useControllableValue = require("../../utils/use-controllable-value");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var defaultProps = {
  defaultDesense: true
};

var DesenseText = function DesenseText(p) {
  var props = (0, _withDefaultProps.mergeProps)(defaultProps, p);
  var text = props.text,
      desenseText = props.desenseText;

  var _useNewControllableVa = (0, _useControllableValue.useNewControllableValue)({
    value: props.desense,
    defaultValue: props.defaultDesense,
    onChange: props.onChange
  }),
      isDesense = _useNewControllableVa[0],
      setIsDesense = _useNewControllableVa[1];

  return (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("span", {
    className: 'adm-desense-text'
  }, isDesense ? desenseText : text, /*#__PURE__*/_react["default"].createElement("a", {
    className: (0, _classnames["default"])('adm-desense-text-icon-wrap', 'adm-plain-anchor'),
    onClick: function onClick() {
      setIsDesense(!isDesense);
    }
  }, /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    component: isDesense ? _iconEyeClose.IconEyeClose : _iconEye.IconEye
  }))));
};

exports.DesenseText = DesenseText;