"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Popup = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _react = _interopRequireWildcard(require("react"));

var _reactTransitionGroup = require("react-transition-group");

var _nativeProps = require("../../utils/native-props");

var _useInitialized = require("../../utils/use-initialized");

var _withDefaultProps = require("../../utils/with-default-props");

var _mask = _interopRequireDefault(require("../mask"));

var _useLockScroll = require("../../utils/use-lock-scroll");

var _renderToContainer = require("../../utils/render-to-container");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var classPrefix = "adm-popup";
var defaultProps = {
  position: 'bottom',
  visible: false,
  getContainer: function getContainer() {
    return document.body;
  },
  mask: true
};

var Popup = function Popup(p) {
  var _classNames, _classNames2;

  var props = (0, _withDefaultProps.mergeProps)(defaultProps, p); // 动画执行完，才隐藏最外层

  var _useState = (0, _react.useState)(!props.visible),
      hidden = _useState[0],
      setHidden = _useState[1];

  (0, _react.useEffect)(function () {
    if (props.visible) {
      setHidden(false);
    }
  }, [props.visible]);

  var afterClose = function afterClose() {
    var _a;

    setHidden(true);
    (_a = props.afterClose) === null || _a === void 0 ? void 0 : _a.call(props);
  };

  var cls = (0, _classnames["default"])(classPrefix, (_classNames = {}, _classNames[classPrefix + "-hidden"] = hidden, _classNames));
  var bodyCls = (0, _classnames["default"])(classPrefix + "-body", props.bodyClassName, (_classNames2 = {}, _classNames2[classPrefix + "-body-hidden"] = !props.visible, _classNames2), classPrefix + "-body-position-" + props.position);
  var initialized = (0, _useInitialized.useInitialized)(props.visible || props.forceRender);
  var ref = (0, _react.useRef)(null);
  (0, _useLockScroll.useLockScroll)(ref, props.visible);
  var node = (0, _nativeProps.withNativeProps)(props, /*#__PURE__*/_react["default"].createElement("div", {
    className: cls,
    onClick: props.onClick
  }, props.mask && /*#__PURE__*/_react["default"].createElement(_mask["default"], {
    visible: props.visible,
    onMaskClick: props.onMaskClick,
    className: props.maskClassName,
    style: props.maskStyle,
    disableBodyScroll: false
  }), /*#__PURE__*/_react["default"].createElement(_reactTransitionGroup.CSSTransition, {
    classNames: classPrefix + "-body",
    "in": props.visible,
    timeout: 200,
    onEntered: props.afterShow,
    onExited: afterClose,
    unmountOnExit: props.destroyOnClose
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: bodyCls,
    style: props.bodyStyle,
    ref: ref
  }, initialized && props.children))));
  return (0, _renderToContainer.renderToContainer)(props.getContainer, node);
};

exports.Popup = Popup;